commit:     1bd881d96b0ced37ff57668b1d02413a3548cca0
Author:     Bernd Waibel <waebbl-gentoo <AT> posteo <DOT> net>
AuthorDate: Wed Apr 28 17:24:56 2021 +0000
Commit:     Sam James <sam <AT> gentoo <DOT> org>
CommitDate: Tue May  4 22:01:24 2021 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=1bd881d9

media-gfx/freecad: bump to 0.19.2

Closes: https://bugs.gentoo.org/785256
Package-Manager: Portage-3.0.18, Repoman-3.0.3
Signed-off-by: Bernd Waibel <waebbl-gentoo <AT> posteo.net>
Closes: https://github.com/gentoo/gentoo/pull/20580
Signed-off-by: Sam James <sam <AT> gentoo.org>

 media-gfx/freecad/Manifest                         |   1 +
 media-gfx/freecad/files/99freecad                  |   1 +
 ...-0001-fix-failing-test-workbench-testcase.patch |  26 ++
 ...2-0002-fix-femtest-failure-with-yaml-load.patch |  26 ++
 ...19.2-0003-fix-test-when-built-without-GUI.patch |  33 +++
 media-gfx/freecad/freecad-0.19.2.ebuild            | 308 +++++++++++++++++++++
 6 files changed, 395 insertions(+)

diff --git a/media-gfx/freecad/Manifest b/media-gfx/freecad/Manifest
index c1b013c5901..486f8202d98 100644
--- a/media-gfx/freecad/Manifest
+++ b/media-gfx/freecad/Manifest
@@ -1 +1,2 @@
 DIST freecad-0.19.1.tar.gz 296983463 BLAKE2B 
de6592474c34c5643ba7f63d6223bf7b2fcee87ebf226727e242ff3f56f363562dd0bae8cb6b3203d978d998b70985777ca93b938c0fc01822e8927cd79f6118
 SHA512 
5134fba99448c509f0761d62b07f1bbd3183108761f41178b38f24d5ba26558608d7d7b00009d03ba097a50cc6fe047bbd57872b32a1d55b3526d18c19ae6393
+DIST freecad-0.19.2.tar.gz 296987961 BLAKE2B 
3c21359c71f7ac5a49cc4b4be437dfce02f2af73dfc526a3955547718ee41c461fc787d029a9a77374d58516d7c56fec6982fe6d38ab17fbc30c0a94929136bf
 SHA512 
420f00e696725cbd31c936c47b6ac226d866a17c7b7683ad381b8dd5edaffc7dfb1a3c4238c08e8b4fd34ef0c08d7c244cb7797012e596df1ce0a4f6e3be6b72

diff --git a/media-gfx/freecad/files/99freecad 
b/media-gfx/freecad/files/99freecad
new file mode 100644
index 00000000000..81104107c22
--- /dev/null
+++ b/media-gfx/freecad/files/99freecad
@@ -0,0 +1 @@
+PYTHONPATH=/usr/lib64/freecad/Ext:/usr/lib64/freecad/Mod:/usr/lib64/freecad/lib64

diff --git 
a/media-gfx/freecad/files/freecad-0.19.2-0001-fix-failing-test-workbench-testcase.patch
 
b/media-gfx/freecad/files/freecad-0.19.2-0001-fix-failing-test-workbench-testcase.patch
new file mode 100644
index 00000000000..58107fb544d
--- /dev/null
+++ 
b/media-gfx/freecad/files/freecad-0.19.2-0001-fix-failing-test-workbench-testcase.patch
@@ -0,0 +1,26 @@
+From dc04c745ea1e7dc277ab06fab69a2b91fbf543c5 Mon Sep 17 00:00:00 2001
+From: Bernd Waibel <waebbl-gen...@posteo.net>
+Date: Sun, 25 Apr 2021 23:02:39 +0200
+Subject: [PATCH] fix failing test workbench testcase
+
+Signed-off-by: Bernd Waibel <waebbl-gen...@posteo.net>
+---
+ src/Mod/Test/Document.py | 2 +-
+ 1 file changed, 1 insertion(+), 1 deletion(-)
+
+diff --git a/src/Mod/Test/Document.py b/src/Mod/Test/Document.py
+index e41375c..fd5eb15 100644
+--- a/src/Mod/Test/Document.py
++++ b/src/Mod/Test/Document.py
+@@ -1307,7 +1307,7 @@ class DocumentFileIncludeCases(unittest.TestCase):
+     # copy file from L5 which is in the same directory
+     L7 = doc2.addObject("App::DocumentObjectFileIncluded","FileObject3")
+     L7.File = (L5.File,"Copy.txt")
+-    self.failUnless(os.path.exists(L5.File))
++    self.failUnless(os.path.exists(L7.File))
+     FreeCAD.closeDocument("Doc2")
+ 
+ 
+-- 
+2.31.1
+

diff --git 
a/media-gfx/freecad/files/freecad-0.19.2-0002-fix-femtest-failure-with-yaml-load.patch
 
b/media-gfx/freecad/files/freecad-0.19.2-0002-fix-femtest-failure-with-yaml-load.patch
new file mode 100644
index 00000000000..17da18c2b12
--- /dev/null
+++ 
b/media-gfx/freecad/files/freecad-0.19.2-0002-fix-femtest-failure-with-yaml-load.patch
@@ -0,0 +1,26 @@
+From a8314fdc56bb39f5af85e1678a03d613bfb9ee03 Mon Sep 17 00:00:00 2001
+From: Bernd Waibel <waebbl-gen...@posteo.net>
+Date: Mon, 26 Apr 2021 19:32:54 +0200
+Subject: [PATCH] fix femtest failure with yaml load
+
+Signed-off-by: Bernd Waibel <waebbl-gen...@posteo.net>
+---
+ src/Mod/Fem/feminout/importYamlJsonMesh.py | 2 +-
+ 1 file changed, 1 insertion(+), 1 deletion(-)
+
+diff --git a/src/Mod/Fem/feminout/importYamlJsonMesh.py 
b/src/Mod/Fem/feminout/importYamlJsonMesh.py
+index 9886248..aff83a5 100644
+--- a/src/Mod/Fem/feminout/importYamlJsonMesh.py
++++ b/src/Mod/Fem/feminout/importYamlJsonMesh.py
+@@ -162,7 +162,7 @@ def read(
+             or fileExtension.lower() == ".yml"
+     ) and has_yaml:
+         fp = pyopen(fileString, "rt")
+-        raw_mesh_data = yaml.load(fp)
++        raw_mesh_data = yaml.load(fp, Loader=yaml.SafeLoader)
+         fp.close()
+     else:
+         Console.PrintError(
+-- 
+2.31.1
+

diff --git 
a/media-gfx/freecad/files/freecad-0.19.2-0003-fix-test-when-built-without-GUI.patch
 
b/media-gfx/freecad/files/freecad-0.19.2-0003-fix-test-when-built-without-GUI.patch
new file mode 100644
index 00000000000..33892ade6d5
--- /dev/null
+++ 
b/media-gfx/freecad/files/freecad-0.19.2-0003-fix-test-when-built-without-GUI.patch
@@ -0,0 +1,33 @@
+From d7ea5a0f20888a2ddae3eb48e508e9067662cdc7 Mon Sep 17 00:00:00 2001
+From: Bernd Waibel <waebbl-gen...@posteo.net>
+Date: Wed, 28 Apr 2021 08:57:53 +0200
+Subject: [PATCH] fix test when built without GUI
+
+Signed-off-by: Bernd Waibel <waebbl-gen...@posteo.net>
+---
+ src/Mod/Arch/ArchRoof.py | 2 +-
+ 1 file changed, 1 insertion(+), 1 deletion(-)
+
+diff --git a/src/Mod/Arch/ArchRoof.py b/src/Mod/Arch/ArchRoof.py
+index 99130d0..e2c2955 100644
+--- a/src/Mod/Arch/ArchRoof.py
++++ b/src/Mod/Arch/ArchRoof.py
+@@ -22,7 +22,6 @@
+ import math
+ 
+ import ArchComponent
+-import Arch_rc
+ import Draft
+ import DraftGeomUtils
+ import DraftVecUtils
+@@ -32,6 +31,7 @@ import Part
+ from FreeCAD import Vector
+ 
+ if FreeCAD.GuiUp:
++    import Arch_rc
+     import FreeCADGui
+     from PySide import QtCore, QtGui
+     from DraftTools import translate
+-- 
+2.31.1
+

diff --git a/media-gfx/freecad/freecad-0.19.2.ebuild 
b/media-gfx/freecad/freecad-0.19.2.ebuild
new file mode 100644
index 00000000000..f2d55fb7b13
--- /dev/null
+++ b/media-gfx/freecad/freecad-0.19.2.ebuild
@@ -0,0 +1,308 @@
+# Copyright 1999-2021 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+# vtk needs updating to use 3.9
+PYTHON_COMPAT=( python3_{7,8} )
+
+inherit check-reqs cmake desktop eapi8-dosym optfeature python-single-r1 xdg
+
+DESCRIPTION="QT based Computer Aided Design application"
+HOMEPAGE="https://www.freecadweb.org/ https://github.com/FreeCAD/FreeCAD";
+
+MY_PN=FreeCAD
+
+if [[ ${PV} = *9999 ]]; then
+       inherit git-r3
+       EGIT_REPO_URI="https://github.com/${MY_PN}/${MY_PN}.git";
+       S="${WORKDIR}/freecad-${PV}"
+else
+       MY_PV=$(ver_cut 1-2)
+       MY_PV=$(ver_rs 1 '_' ${MY_PV})
+       
SRC_URI="https://github.com/${MY_PN}/${MY_PN}/archive/refs/tags/${PV}.tar.gz -> 
${P}.tar.gz"
+       KEYWORDS="~amd64"
+       S="${WORKDIR}/FreeCAD-${PV}"
+fi
+
+# code is licensed LGPL-2
+# examples are licensed CC-BY-SA (without note of specific version)
+LICENSE="LGPL-2 CC-BY-SA-4.0"
+SLOT="0"
+IUSE="debug headless pcl test"
+RESTRICT="!test? ( test )"
+
+FREECAD_EXPERIMENTAL_MODULES="cloud plot ship"
+FREECAD_STABLE_MODULES="addonmgr fem idf image inspection material
+       openscad part-design path points raytracing robot show surface
+       techdraw tux"
+
+for module in ${FREECAD_STABLE_MODULES}; do
+       IUSE="${IUSE} +${module}"
+done
+for module in ${FREECAD_EXPERIMENTAL_MODULES}; do
+       IUSE="${IUSE} -${module}"
+done
+unset module
+
+RDEPEND="
+       ${PYTHON_DEPS}
+       >=dev-cpp/eigen-3.3.1:3
+       dev-libs/OpenNI2[opengl(+)]
+       dev-libs/libspnav[X]
+       dev-libs/xerces-c[icu]
+       dev-qt/designer:5
+       dev-qt/qtconcurrent:5
+       dev-qt/qtcore:5
+       dev-qt/qtgui:5
+       dev-qt/qtnetwork:5
+       dev-qt/qtopengl:5
+       dev-qt/qtprintsupport:5
+       dev-qt/qtsvg:5
+       dev-qt/qtwebengine:5[widgets]
+       dev-qt/qtwidgets:5
+       dev-qt/qtx11extras:5
+       dev-qt/qtxml:5
+       >=media-libs/coin-4.0.0
+       media-libs/freetype
+       media-libs/qhull
+       sci-libs/flann[openmp]
+       sci-libs/hdf5:=[fortran,zlib]
+       >=sci-libs/med-4.0.0-r1[python,${PYTHON_SINGLE_USEDEP}]
+       sci-libs/opencascade:=[vtk(+)]
+       sci-libs/orocos_kdl:=
+       sys-libs/zlib
+       virtual/glu
+       virtual/libusb:1
+       virtual/opengl
+       cloud? (
+               dev-libs/openssl:=
+               net-misc/curl
+       )
+       fem? ( 
<sci-libs/vtk-9[boost,python,qt5,rendering,${PYTHON_SINGLE_USEDEP}] )
+       openscad? ( media-gfx/openscad )
+       pcl? ( >=sci-libs/pcl-1.8.1:=[opengl,openni2(+),qt5(+),vtk(+)] )
+       $(python_gen_cond_dep '
+               dev-libs/boost:=[python,threads,${PYTHON_MULTI_USEDEP}]
+               dev-python/matplotlib[${PYTHON_MULTI_USEDEP}]
+               dev-python/numpy[${PYTHON_MULTI_USEDEP}]
+               >=dev-python/pivy-0.6.5[${PYTHON_MULTI_USEDEP}]
+               dev-python/pybind11[${PYTHON_MULTI_USEDEP}]
+               dev-python/pyside2[gui,svg,${PYTHON_MULTI_USEDEP}]
+               dev-python/shiboken2[${PYTHON_MULTI_USEDEP}]
+               addonmgr? ( dev-python/GitPython[${PYTHON_MULTI_USEDEP}] )
+               fem? ( dev-python/ply[${PYTHON_MULTI_USEDEP}] )
+       ')
+"
+DEPEND="${RDEPEND}"
+BDEPEND="dev-lang/swig"
+
+# To get required dependencies:
+# 'grep REQUIRES_MODS cMake/FreeCAD_Helpers/CheckInterModuleDependencies.cmake'
+# We set the following requirements by default:
+# arch, draft, drawing, import, mesh, part, qt5, sketcher, spreadsheet, start, 
web.
+#
+# Additionally, we auto-enable mesh_part, flat_mesh and smesh
+# Fem actually needs smesh, but as long as we don't have a smesh package, we 
enable
+# smesh through the mesh USE flag. Note however, the fem<-smesh dependency 
isn't
+# reflected by the REQUIRES_MODS macro, but at
+# cMake/FreeCAD_Helpers/InitializeFreeCADBuildOptions.cmake:187.
+#
+# The increase in auto-enabled workbenches is due to their need in parts of the
+# test suite when compiled with a minimal set of USE flags.
+REQUIRED_USE="
+       ${PYTHON_REQUIRED_USE}
+       inspection? ( points )
+       path? ( robot )
+       ship? ( image plot )
+"
+
+PATCHES=(
+       
"${FILESDIR}"/${PN}-0.19_pre20201231-0003-Gentoo-specific-don-t-check-vcs.patch
+       
"${FILESDIR}"/${PN}-0.19.1-0001-Gentoo-specific-Remove-ccache-usage.patch
+       "${FILESDIR}"/${P}-0001-fix-failing-test-workbench-testcase.patch
+       "${FILESDIR}"/${P}-0002-fix-femtest-failure-with-yaml-load.patch
+       "${FILESDIR}"/${P}-0003-fix-test-when-built-without-GUI.patch
+)
+
+DOCS=( CODE_OF_CONDUCT.md ChangeLog.txt README.md )
+
+CHECKREQS_DISK_BUILD="2G"
+
+pkg_setup() {
+       check-reqs_pkg_setup
+       python-single-r1_pkg_setup
+       [[ -z ${CASROOT} ]] && die "\${CASROOT} not set, plesae run eselect 
opencascade"
+}
+
+src_prepare() {
+       # the upstream provided file doesn't find the coin doc tag file,
+       # but cmake ships a working one, so we use this.
+       rm "${S}/cMake/FindCoin3D.cmake" || die
+
+       # Fix OpenCASCADE lookup
+       # TODO: check this for opencascade-7.5.1 locations, which have
+       # changed since 7.4.0 after that package has merged
+       sed -e 's|/usr/include/opencascade|${CASROOT}/include/opencascade|' \
+               -e 's|/usr/lib|${CASROOT}/'$(get_libdir)' NO_DEFAULT_PATH|' \
+               -i cMake/FindOpenCasCade.cmake || die
+
+       # Fix desktop file
+       sed -e 's/Exec=FreeCAD/Exec=freecad/' -i 
src/XDGData/org.freecadweb.FreeCAD.desktop || die
+
+       cmake_src_prepare
+}
+
+src_configure() {
+       local mycmakeargs=(
+               -DBUILD_ADDONMGR=$(usex addonmgr)
+               -DBUILD_ARCH=ON
+               -DBUILD_ASSEMBLY=OFF                                    # 
deprecated
+               -DBUILD_CLOUD=$(usex cloud)
+               -DBUILD_COMPLETE=OFF                                    # 
deprecated
+               -DBUILD_DRAFT=ON
+               -DBUILD_DRAWING=ON
+               -DBUILD_ENABLE_CXX_STD:STRING="C++14"   # needed for 
>=boost-1.75.0
+               -DBUILD_FEM=$(usex fem)
+               -DBUILD_FEM_NETGEN=OFF
+               -DBUILD_FLAT_MESH=ON
+               -DBUILD_FORCE_DIRECTORY=ON                              # force 
building in a dedicated directory
+               -DBUILD_FREETYPE=ON                                             
# automagic dep
+               -DBUILD_GUI=$(usex !headless)
+               -DBUILD_IDF=$(usex idf)
+               -DBUILD_IMAGE=$(usex image)
+               -DBUILD_IMPORT=ON                                               
# import module for various file formats
+               -DBUILD_INSPECTION=$(usex inspection)
+               -DBUILD_JTREADER=OFF                                    # code 
has been removed upstream, but option is still there
+               -DBUILD_MATERIAL=$(usex material)
+               -DBUILD_MESH=ON
+               -DBUILD_MESH_PART=ON
+               -DBUILD_OPENSCAD=$(usex openscad)
+               -DBUILD_PART=ON
+               -DBUILD_PART_DESIGN=$(usex part-design)
+               -DBUILD_PATH=$(usex path)
+               -DBUILD_PLOT=$(usex plot)                               # 
conflicts with possible external workbench
+               -DBUILD_POINTS=$(usex points)
+               -DBUILD_QT5=ON                                                  
# OFF means to use Qt4
+               -DBUILD_RAYTRACING=$(usex raytracing)
+               -DBUILD_REVERSEENGINEERING=OFF                  # currently 
only an empty sandbox
+               -DBUILD_ROBOT=$(usex robot)
+               -DBUILD_SHIP=$(usex ship)                               # 
conflicts with possible external workbench
+               -DBUILD_SHOW=$(usex show)
+               -DBUILD_SKETCHER=ON                                             
# needed by draft workspace
+               -DBUILD_SMESH=ON
+               -DBUILD_SPREADSHEET=ON
+               -DBUILD_START=ON
+               -DBUILD_SURFACE=$(usex surface)
+               -DBUILD_TECHDRAW=$(usex techdraw)
+               -DBUILD_TEST=ON                                                 
# always build test workbench for run-time testing
+               -DBUILD_TUX=$(usex tux)
+               -DBUILD_VR=OFF
+               -DBUILD_WEB=ON                                                  
# needed by start workspace
+               -DBUILD_WITH_CONDA=OFF
+
+               -DCMAKE_INSTALL_DATADIR=/usr/share/${PN}/data
+               -DCMAKE_INSTALL_DOCDIR=/usr/share/doc/${PF}
+               -DCMAKE_INSTALL_INCLUDEDIR=/usr/include/${PN}
+               -DCMAKE_INSTALL_PREFIX=/usr/$(get_libdir)/${PN}
+
+               -DFREECAD_BUILD_DEBIAN=OFF
+
+               -DFREECAD_USE_EXTERNAL_KDL=ON
+               -DFREECAD_USE_EXTERNAL_SMESH=OFF                # no package in 
Gentoo
+               -DFREECAD_USE_EXTERNAL_ZIPIOS=OFF               # doesn't work 
yet, also no package in Gentoo tree
+               -DFREECAD_USE_FREETYPE=ON
+               -DFREECAD_USE_OCC_VARIANT:STRING="Official Version"
+               -DFREECAD_USE_PCL=$(usex pcl)
+               -DFREECAD_USE_PYBIND11=ON
+               -DFREECAD_USE_QT_FILEDIALOG=ON
+               -DFREECAD_USE_QTWEBMODULE:STRING="Qt WebEngine"
+
+               # install python modules to site-packages' dir. True only for 
the main package,
+               # sub-packages will still be installed inside /usr/lib64/freecad
+               -DINSTALL_TO_SITEPACKAGES=ON
+
+               -DOCC_INCLUDE_DIR="${CASROOT}"/include/opencascade
+               -DOCC_LIBRARY_DIR="${CASROOT}"/$(get_libdir)
+               -DOCCT_CMAKE_FALLBACK=ON                                # don't 
use occt-config which isn't included in opencascade for Gentoo
+       )
+
+       if use debug; then
+               mycmakeargs+=(
+                       -DBUILD_SANDBOX=ON
+                       -DBUILD_TEMPLATE=ON
+               )
+       else
+               mycmakeargs+=(
+                       -DBUILD_SANDBOX=OFF
+                       -DBUILD_TEMPLATE=OFF
+               )
+       fi
+
+       cmake_src_configure
+}
+
+# We use the FreeCADCmd binary instead of the FreeCAD binary here
+# for two reasons:
+# 1. It works out of the box with USE=headless as well, not needing a guard
+# 2. We don't need virtualx.eclass and it's dependencies
+# The exported environment variables are needed, so freecad does know
+# where to save it's temporary files, and where to look and write it's
+# configuration. Without those, there are sandbox violation, when it
+# tries to create /var/lib/portage/home/.FreeCAD directory.
+src_test() {
+       pushd "${BUILD_DIR}" > /dev/null || die
+       export FREECAD_USER_HOME="${HOME}"
+       export FREECAD_USER_DATA="${T}"
+       export FREECAD_USER_TEMP="${T}"
+       nonfatal ./bin/FreeCADCmd --run-test 0
+       popd > /dev/null || die
+}
+
+src_install() {
+       cmake_src_install
+
+       if ! use headless; then
+               dosym8 -r /usr/$(get_libdir)/${PN}/bin/FreeCAD /usr/bin/freecad
+               mv "${ED}"/usr/$(get_libdir)/freecad/share/* "${ED}"/usr/share 
|| die "failed to move shared ressources"
+       fi
+       dosym8 -r /usr/$(get_libdir)/${PN}/bin/FreeCADCmd /usr/bin/freecadcmd
+
+       python_optimize "${ED}"/usr/share/${PN}/data/Mod/Start/StartPage 
"${ED}"/usr/$(get_libdir)/${PN}{/Ext,/Mod}/
+       # compile main package in python site-packages as well
+       python_optimize
+
+       doenvd "${FILESDIR}/99${PN}"
+}
+
+pkg_postinst() {
+       xdg_pkg_postinst
+
+       if use plot; then
+               einfo "Note: You are enabling the 'plot' USE flag."
+               einfo "This conflicts with the plot workbench that can be 
loaded"
+               einfo "via the addon manager! You can only install one of 
those."
+       fi
+
+       if use ship; then
+               einfo "Note: You are enabling the 'ship' USE flag."
+               einfo "This conflicts with the ship workbench that can be 
loaded"
+               einfo "via the addon manager! You can only install one of 
those."
+       fi
+
+       einfo "You can load a lot of additional workbenches using the 
integrated"
+       einfo "AddonManager."
+
+       einfo "There are a lot of additional tools, for which FreeCAD has 
builtin"
+       einfo "support. Some of them are available in Gentoo. Take a look at"
+       einfo 
"https://wiki.freecadweb.org/Installing#External_software_supported_by_FreeCAD";
+       optfeature "interact with git repositories" dev-python/GitPython
+       optfeature "work with COLLADA documents" dev-python/pycollada
+       optfeature "dependency graphs" media-gfx/graphviz
+       optfeature "PBR Rendering" media-gfx/povray
+       optfeature "FEM mesh generator" sci-libs/gmsh
+}
+
+pkg_postrm() {
+       xdg_pkg_postrm
+}

Reply via email to